opcodes: Replace manual loop with map
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 SHELL_ENV_INIT = autotools/shell-env-init
35
36 # Note: these are automake-specific variables, and must be named after
37 # the directory + 'dir' suffix
38 clientdir = $(pkgpythondir)/client
39 hypervisordir = $(pkgpythondir)/hypervisor
40 httpdir = $(pkgpythondir)/http
41 masterddir = $(pkgpythondir)/masterd
42 confddir = $(pkgpythondir)/confd
43 rapidir = $(pkgpythondir)/rapi
44 serverdir = $(pkgpythondir)/server
45 watcherdir = $(pkgpythondir)/watcher
46 impexpddir = $(pkgpythondir)/impexpd
47 utilsdir = $(pkgpythondir)/utils
48 toolsdir = $(pkglibdir)/tools
49 iallocatorsdir = $(pkglibdir)/iallocators
50 pytoolsdir = $(pkgpythondir)/tools
51 docdir = $(datadir)/doc/$(PACKAGE)
52 myexeclibdir = $(pkglibdir)
53
54 # Delete output file if an error occurred while building it
55 .DELETE_ON_ERROR:
56
57 HTOOLS_DIRS = \
58         htools \
59         htools/Ganeti \
60         htools/Ganeti/Block \
61         htools/Ganeti/Block/Drbd \
62         htools/Ganeti/Confd \
63         htools/Ganeti/HTools \
64         htools/Ganeti/HTools/Backend \
65         htools/Ganeti/HTools/Program \
66         htools/Ganeti/Query \
67         htest \
68         htest/Test \
69         htest/Test/Ganeti \
70         htest/Test/Ganeti/Block \
71         htest/Test/Ganeti/Block/Drbd \
72         htest/Test/Ganeti/Confd \
73         htest/Test/Ganeti/HTools \
74         htest/Test/Ganeti/HTools/Backend \
75         htest/Test/Ganeti/Query
76
77 DIRS = \
78         $(HTOOLS_DIRS) \
79         autotools \
80         daemons \
81         devel \
82         doc \
83         doc/examples \
84         doc/examples/gnt-debug \
85         doc/examples/hooks \
86         htest/data \
87         htest/data/rapi \
88         htest/shelltests \
89         lib \
90         lib/build \
91         lib/client \
92         lib/confd \
93         lib/http \
94         lib/hypervisor \
95         lib/impexpd \
96         lib/masterd \
97         lib/rapi \
98         lib/server \
99         lib/tools \
100         lib/utils \
101         lib/watcher \
102         man \
103         qa \
104         test \
105         test/data \
106         test/data/ovfdata \
107         test/data/ovfdata/other \
108         tools
109
110 BUILDTIME_DIR_AUTOCREATE = \
111         scripts \
112         $(APIDOC_DIR) \
113         $(APIDOC_HS_DIR) \
114         $(APIDOC_HS_DIR)/Ganeti \
115         $(APIDOC_HS_DIR)/Ganeti/Block \
116         $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
117         $(APIDOC_HS_DIR)/Ganeti/Confd \
118         $(APIDOC_HS_DIR)/Ganeti/HTools \
119         $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
120         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
121         $(APIDOC_HS_DIR)/Ganeti/Query \
122         $(APIDOC_PY_DIR) \
123         $(COVERAGE_DIR) \
124         $(COVERAGE_HS_DIR) \
125         $(COVERAGE_PY_DIR) \
126         .hpc
127
128 BUILDTIME_DIRS = \
129         $(BUILDTIME_DIR_AUTOCREATE) \
130         doc/html
131
132 DIRCHECK_EXCLUDE = \
133         $(BUILDTIME_DIRS) \
134         ganeti-[0-9]*.[0-9]*.[0-9]* \
135         doc/html/_*
136
137 # some helper vars
138 COVERAGE_DIR = doc/coverage
139 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
140 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
141 APIDOC_DIR = doc/api
142 APIDOC_PY_DIR = $(APIDOC_DIR)/py
143 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
144
145 MAINTAINERCLEANFILES = \
146         $(docpng) \
147         $(maninput) \
148         doc/install-quick.rst \
149         doc/news.rst \
150         doc/upgrade.rst \
151         vcs-version
152
153 maintainer-clean-local:
154         rm -rf $(BUILDTIME_DIRS)
155
156 CLEANFILES = \
157         $(addsuffix /*.py[co],$(DIRS)) \
158         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
159         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
160         $(PYTHON_BOOTSTRAP) \
161         epydoc.conf \
162         $(REPLACE_VARS_SED) \
163         $(SHELL_ENV_INIT) \
164         daemons/daemon-util \
165         daemons/ganeti-cleaner \
166         $(BUILT_EXAMPLES) \
167         doc/examples/bash_completion \
168         doc/examples/bash_completion-debug \
169         lib/_generated_rpc.py \
170         $(man_MANS) \
171         $(manhtml) \
172         tools/kvm-ifup \
173         tools/vcluster-setup \
174         stamp-directories \
175         stamp-srclinks \
176         $(nodist_pkgpython_PYTHON) \
177         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
178         $(HS_BUILT_TEST_HELPERS) \
179         htools/ganeti-confd \
180         .hpc/*.mix htools/*.tix htest/*.tix \
181         doc/hs-lint.html
182
183 GENERATED_FILES = \
184         $(built_base_sources) \
185         $(BUILT_PYTHON_SOURCES) \
186         $(PYTHON_BOOTSTRAP)
187
188 HTOOLS_GENERATED_FILES =
189 if WANT_HTOOLS
190 HTOOLS_GENERATED_FILES += $(HS_PROGS)
191 if ENABLE_CONFD
192 HTOOLS_GENERATED_FILES += htools/hconfd htools/ganeti-confd
193 endif
194 endif
195
196 built_base_sources = \
197         stamp-directories \
198         stamp-srclinks
199
200 built_python_base_sources = \
201         lib/_autoconf.py \
202         lib/_vcsversion.py
203
204 BUILT_PYTHON_SOURCES = \
205         $(built_python_base_sources) \
206         lib/_generated_rpc.py
207
208 # Generating the RPC wrappers depends on many things, so make sure
209 # it's built at the end of the built sources
210 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
211
212 # these are all built from the underlying %.in sources
213 BUILT_EXAMPLES = \
214         doc/examples/ganeti-kvm-poweroff.initd \
215         doc/examples/ganeti.cron \
216         doc/examples/ganeti.initd \
217         doc/examples/ganeti-master-role.ocf \
218         doc/examples/ganeti-node-role.ocf \
219         doc/examples/gnt-config-backup \
220         doc/examples/hooks/ipsec
221
222 nodist_pkgpython_PYTHON = \
223         $(BUILT_PYTHON_SOURCES)
224
225 noinst_PYTHON = \
226         lib/build/__init__.py \
227         lib/build/shell_example_lexer.py \
228         lib/build/sphinx_ext.py
229
230 pkgpython_PYTHON = \
231         lib/__init__.py \
232         lib/asyncnotifier.py \
233         lib/backend.py \
234         lib/bdev.py \
235         lib/bootstrap.py \
236         lib/cli.py \
237         lib/cmdlib.py \
238         lib/compat.py \
239         lib/config.py \
240         lib/constants.py \
241         lib/daemon.py \
242         lib/errors.py \
243         lib/ht.py \
244         lib/jqueue.py \
245         lib/jstore.py \
246         lib/locking.py \
247         lib/luxi.py \
248         lib/mcpu.py \
249         lib/netutils.py \
250         lib/objects.py \
251         lib/objectutils.py \
252         lib/opcodes.py \
253         lib/ovf.py \
254         lib/pathutils.py \
255         lib/qlang.py \
256         lib/query.py \
257         lib/rpc.py \
258         lib/rpc_defs.py \
259         lib/runtime.py \
260         lib/serializer.py \
261         lib/ssconf.py \
262         lib/ssh.py \
263         lib/storage.py \
264         lib/uidpool.py \
265         lib/vcluster.py \
266         lib/network.py \
267         lib/workerpool.py
268
269 client_PYTHON = \
270         lib/client/__init__.py \
271         lib/client/gnt_backup.py \
272         lib/client/gnt_cluster.py \
273         lib/client/gnt_debug.py \
274         lib/client/gnt_group.py \
275         lib/client/gnt_instance.py \
276         lib/client/gnt_job.py \
277         lib/client/gnt_node.py \
278         lib/client/gnt_network.py \
279         lib/client/gnt_os.py
280
281 hypervisor_PYTHON = \
282         lib/hypervisor/__init__.py \
283         lib/hypervisor/hv_base.py \
284         lib/hypervisor/hv_chroot.py \
285         lib/hypervisor/hv_fake.py \
286         lib/hypervisor/hv_kvm.py \
287         lib/hypervisor/hv_lxc.py \
288         lib/hypervisor/hv_xen.py
289
290 rapi_PYTHON = \
291         lib/rapi/__init__.py \
292         lib/rapi/baserlib.py \
293         lib/rapi/client.py \
294         lib/rapi/client_utils.py \
295         lib/rapi/connector.py \
296         lib/rapi/rlib2.py \
297         lib/rapi/testutils.py
298
299 http_PYTHON = \
300         lib/http/__init__.py \
301         lib/http/auth.py \
302         lib/http/client.py \
303         lib/http/server.py
304
305 confd_PYTHON = \
306         lib/confd/__init__.py \
307         lib/confd/client.py
308
309 masterd_PYTHON = \
310         lib/masterd/__init__.py \
311         lib/masterd/iallocator.py \
312         lib/masterd/instance.py
313
314 impexpd_PYTHON = \
315         lib/impexpd/__init__.py
316
317 watcher_PYTHON = \
318         lib/watcher/__init__.py \
319         lib/watcher/nodemaint.py \
320         lib/watcher/state.py
321
322 server_PYTHON = \
323         lib/server/__init__.py \
324         lib/server/masterd.py \
325         lib/server/noded.py \
326         lib/server/rapi.py
327
328 pytools_PYTHON = \
329         lib/tools/__init__.py \
330         lib/tools/ensure_dirs.py \
331         lib/tools/prepare_node_join.py
332
333 utils_PYTHON = \
334         lib/utils/__init__.py \
335         lib/utils/algo.py \
336         lib/utils/filelock.py \
337         lib/utils/hash.py \
338         lib/utils/io.py \
339         lib/utils/log.py \
340         lib/utils/mlock.py \
341         lib/utils/nodesetup.py \
342         lib/utils/process.py \
343         lib/utils/retry.py \
344         lib/utils/text.py \
345         lib/utils/wrapper.py \
346         lib/utils/x509.py
347
348 docrst = \
349         doc/admin.rst \
350         doc/cluster-merge.rst \
351         doc/design-2.0.rst \
352         doc/design-2.1.rst \
353         doc/design-2.2.rst \
354         doc/design-2.3.rst \
355         doc/design-2.4.rst \
356         doc/design-2.5.rst \
357         doc/design-2.6.rst \
358         doc/design-2.7.rst \
359         doc/design-autorepair.rst \
360         doc/design-bulk-create.rst \
361         doc/design-chained-jobs.rst \
362         doc/design-cpu-pinning.rst \
363         doc/design-draft.rst \
364         doc/design-htools-2.3.rst \
365         doc/design-http-server.rst \
366         doc/design-impexp2.rst \
367         doc/design-lu-generated-jobs.rst \
368         doc/design-linuxha.rst \
369         doc/design-multi-reloc.rst \
370         doc/design-network.rst \
371         doc/design-node-add.rst \
372         doc/design-oob.rst \
373         doc/design-ovf-support.rst \
374         doc/design-partitioned.rst \
375         doc/design-query-splitting.rst \
376         doc/design-query2.rst \
377         doc/design-remote-commands.rst \
378         doc/design-resource-model.rst \
379         doc/design-shared-storage.rst \
380         doc/design-monitoring-agent.rst \
381         doc/design-virtual-clusters.rst \
382         doc/design-x509-ca.rst \
383         doc/devnotes.rst \
384         doc/glossary.rst \
385         doc/hooks.rst \
386         doc/iallocator.rst \
387         doc/index.rst \
388         doc/install-quick.rst \
389         doc/install.rst \
390         doc/locking.rst \
391         doc/move-instance.rst \
392         doc/news.rst \
393         doc/ovfconverter.rst \
394         doc/rapi.rst \
395         doc/security.rst \
396         doc/upgrade.rst \
397         doc/virtual-cluster.rst \
398         doc/walkthrough.rst
399
400 HS_PROGS = htools/htools
401 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
402 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
403
404 HS_ALL_PROGS = \
405         $(HS_PROGS) \
406         htest/hpc-htools \
407         htest/test \
408         htools/hconfd \
409         htools/rpc-test
410
411 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
412 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
413
414 HFLAGS = \
415         -O -Wall -Werror -ihtools \
416         -fwarn-monomorphism-restriction \
417         -fwarn-tabs \
418         $(GHC_BYVERSION_FLAGS)
419
420 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
421 HEXTRA =
422 # internal extra flags (used for htest/test mainly)
423 HEXTRA_INT =
424 # exclude options for coverage reports
425 HPCEXCL = --exclude Main \
426         --exclude Ganeti.Constants \
427         --exclude Ganeti.HTools.QC \
428         --exclude Ganeti.THH \
429         --exclude Ganeti.Version \
430         --exclude Test.Ganeti.Attoparsec \
431         --exclude Test.Ganeti.TestCommon \
432         --exclude Test.Ganeti.TestHTools \
433         --exclude Test.Ganeti.TestHelper \
434         --exclude Test.Ganeti.TestImports \
435         $(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
436
437 HS_LIB_SRCS = \
438         htools/Ganeti/Block/Drbd/Types.hs \
439         htools/Ganeti/Block/Drbd/Parser.hs \
440         htools/Ganeti/BasicTypes.hs \
441         htools/Ganeti/Common.hs \
442         htools/Ganeti/Compat.hs \
443         htools/Ganeti/Confd/Server.hs \
444         htools/Ganeti/Confd/Types.hs \
445         htools/Ganeti/Confd/Utils.hs \
446         htools/Ganeti/Config.hs \
447         htools/Ganeti/Daemon.hs \
448         htools/Ganeti/Errors.hs \
449         htools/Ganeti/HTools/Backend/IAlloc.hs \
450         htools/Ganeti/HTools/Backend/Luxi.hs \
451         htools/Ganeti/HTools/Backend/Rapi.hs \
452         htools/Ganeti/HTools/Backend/Simu.hs \
453         htools/Ganeti/HTools/Backend/Text.hs \
454         htools/Ganeti/HTools/CLI.hs \
455         htools/Ganeti/HTools/Cluster.hs \
456         htools/Ganeti/HTools/Container.hs \
457         htools/Ganeti/HTools/ExtLoader.hs \
458         htools/Ganeti/HTools/Group.hs \
459         htools/Ganeti/HTools/Instance.hs \
460         htools/Ganeti/HTools/Loader.hs \
461         htools/Ganeti/HTools/Node.hs \
462         htools/Ganeti/HTools/PeerMap.hs \
463         htools/Ganeti/HTools/Program.hs \
464         htools/Ganeti/HTools/Program/Hail.hs \
465         htools/Ganeti/HTools/Program/Hbal.hs \
466         htools/Ganeti/HTools/Program/Hcheck.hs \
467         htools/Ganeti/HTools/Program/Hinfo.hs \
468         htools/Ganeti/HTools/Program/Hscan.hs \
469         htools/Ganeti/HTools/Program/Hspace.hs \
470         htools/Ganeti/HTools/Types.hs \
471         htools/Ganeti/Hash.hs \
472         htools/Ganeti/JSON.hs \
473         htools/Ganeti/Jobs.hs \
474         htools/Ganeti/Logging.hs \
475         htools/Ganeti/Luxi.hs \
476         htools/Ganeti/Objects.hs \
477         htools/Ganeti/OpCodes.hs \
478         htools/Ganeti/OpParams.hs \
479         htools/Ganeti/Path.hs \
480         htools/Ganeti/Query/Common.hs \
481         htools/Ganeti/Query/Filter.hs \
482         htools/Ganeti/Query/Group.hs \
483         htools/Ganeti/Query/Language.hs \
484         htools/Ganeti/Query/Node.hs \
485         htools/Ganeti/Query/Query.hs \
486         htools/Ganeti/Query/Server.hs \
487         htools/Ganeti/Query/Types.hs \
488         htools/Ganeti/Rpc.hs \
489         htools/Ganeti/Runtime.hs \
490         htools/Ganeti/Ssconf.hs \
491         htools/Ganeti/THH.hs \
492         htools/Ganeti/Types.hs \
493         htools/Ganeti/Utils.hs
494
495 HS_TEST_SRCS = \
496         htest/Test/Ganeti/Attoparsec.hs \
497         htest/Test/Ganeti/BasicTypes.hs \
498         htest/Test/Ganeti/Block/Drbd/Parser.hs \
499         htest/Test/Ganeti/Common.hs \
500         htest/Test/Ganeti/Confd/Utils.hs \
501         htest/Test/Ganeti/Daemon.hs \
502         htest/Test/Ganeti/Errors.hs \
503         htest/Test/Ganeti/HTools/Backend/Simu.hs \
504         htest/Test/Ganeti/HTools/Backend/Text.hs \
505         htest/Test/Ganeti/HTools/CLI.hs \
506         htest/Test/Ganeti/HTools/Cluster.hs \
507         htest/Test/Ganeti/HTools/Container.hs \
508         htest/Test/Ganeti/HTools/Instance.hs \
509         htest/Test/Ganeti/HTools/Loader.hs \
510         htest/Test/Ganeti/HTools/Node.hs \
511         htest/Test/Ganeti/HTools/PeerMap.hs \
512         htest/Test/Ganeti/HTools/Types.hs \
513         htest/Test/Ganeti/JSON.hs \
514         htest/Test/Ganeti/Jobs.hs \
515         htest/Test/Ganeti/Luxi.hs \
516         htest/Test/Ganeti/Objects.hs \
517         htest/Test/Ganeti/OpCodes.hs \
518         htest/Test/Ganeti/Query/Filter.hs \
519         htest/Test/Ganeti/Query/Language.hs \
520         htest/Test/Ganeti/Query/Query.hs \
521         htest/Test/Ganeti/Rpc.hs \
522         htest/Test/Ganeti/Ssconf.hs \
523         htest/Test/Ganeti/THH.hs \
524         htest/Test/Ganeti/TestCommon.hs \
525         htest/Test/Ganeti/TestHTools.hs \
526         htest/Test/Ganeti/TestHelper.hs \
527         htest/Test/Ganeti/Types.hs \
528         htest/Test/Ganeti/Utils.hs
529
530 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
531
532 HS_BUILT_SRCS = \
533         htest/Test/Ganeti/TestImports.hs \
534         htools/Ganeti/Constants.hs \
535         htools/Ganeti/Version.hs
536 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
537
538 $(RUN_IN_TEMPDIR): | stamp-directories
539
540 # Note: we use here an order-only prerequisite, as the contents of
541 # _autoconf.py are not actually influencing the html build output: it
542 # has to exist in order for the sphinx module to be loaded
543 # successfully, but we certainly don't want the docs to be rebuilt if
544 # it changes
545 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
546         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
547         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
548         | $(BUILT_PYTHON_SOURCES)
549         @test -n "$(SPHINX)" || \
550             { echo 'sphinx-build' not found during configure; exit 1; }
551         @mkdir_p@ $(dir $@)
552         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
553             -d . \
554             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
555             -D release="$(PACKAGE_VERSION)" \
556             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
557         rm -f doc/html/.buildinfo doc/html/objects.inv
558         touch $@
559
560 doc/html: doc/html/index.html
561
562 doc/install-quick.rst: INSTALL
563 doc/news.rst: NEWS
564 doc/upgrade.rst: UPGRADE
565
566 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
567         set -e; \
568         { echo '.. This file is automatically updated at build time from $<.'; \
569           echo '.. Do not edit.'; \
570           echo; \
571           cat $<; \
572         } > $@
573
574 docdot = \
575         doc/arch-2.0.dot \
576         doc/design-2.1-lock-acquire.dot \
577         doc/design-2.1-lock-release.dot
578
579 docpng = $(patsubst %.dot,%.png,$(docdot))
580
581 # Things to build but not to install (add it to EXTRA_DIST if it should be
582 # distributed)
583 noinst_DATA = \
584         doc/html \
585         $(BUILT_EXAMPLES) \
586         doc/examples/bash_completion \
587         doc/examples/bash_completion-debug \
588         $(manhtml)
589
590 gnt_scripts = \
591         scripts/gnt-backup \
592         scripts/gnt-cluster \
593         scripts/gnt-debug \
594         scripts/gnt-group \
595         scripts/gnt-instance \
596         scripts/gnt-job \
597         scripts/gnt-network \
598         scripts/gnt-node \
599         scripts/gnt-os
600
601 PYTHON_BOOTSTRAP_SBIN = \
602         daemons/ganeti-masterd \
603         daemons/ganeti-noded \
604         daemons/ganeti-rapi \
605         daemons/ganeti-watcher \
606         $(gnt_scripts)
607
608 PYTHON_BOOTSTRAP = \
609         $(PYTHON_BOOTSTRAP_SBIN) \
610         tools/ensure-dirs \
611         tools/prepare-node-join
612
613 qa_scripts = \
614         qa/__init__.py \
615         qa/ganeti-qa.py \
616         qa/qa_cluster.py \
617         qa/qa_config.py \
618         qa/qa_daemon.py \
619         qa/qa_env.py \
620         qa/qa_error.py \
621         qa/qa_group.py \
622         qa/qa_instance.py \
623         qa/qa_job.py \
624         qa/qa_node.py \
625         qa/qa_os.py \
626         qa/qa_rapi.py \
627         qa/qa_tags.py \
628         qa/qa_utils.py
629
630 bin_SCRIPTS =
631 if WANT_HTOOLS
632 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
633 install-exec-hook:
634         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
635 # FIXME: this is a hardcoded logic, instead of auto-resolving
636         $(LN_S) -f ../../../bin/htools \
637                    $(DESTDIR)$(iallocatorsdir)/hail
638         for role in $(HS_BIN_ROLES); do \
639                 $(LN_S) -f htools \
640                            $(DESTDIR)$(bindir)/$$role ; \
641         done
642 endif
643
644 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
645         @if [ "$(notdir $@)" = "test" ] && [ "$(HTOOLS_NODEV)" ]; then \
646           echo "Error: cannot run unittests without the development" \
647                " libraries (see devnotes.rst)" 1>&2; \
648           exit 1; \
649         fi
650         @rm -f $(notdir $@).tix
651         $(GHC) --make \
652           $(HFLAGS) \
653           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
654           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
655           $(HEXTRA) $(HEXTRA_INT) $@
656         @touch "$@"
657
658 # for the htest/test binary, we need to enable profiling/coverage
659 htest/test: HEXTRA_INT=-fhpc -ihtest
660
661 # we compile the hpc-htools binary with the program coverage
662 htest/hpc-htools: HEXTRA_INT=-fhpc
663
664 # test dependency
665 htest/offline-tests.sh: htest/hpc-htools
666
667 # rules for building profiling-enabled versions of the haskell
668 # programs: hs-prof does the full two-step build, whereas
669 # hs-prof-quick does only the final rebuild (hs-prof must have been
670 # run before)
671 .PHONY: hs-prof hs-prof-quick
672 hs-prof:
673         $(MAKE) $(AM_MAKEFLAGS) clean
674         $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
675         rm -f $(HS_ALL_PROGS)
676         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
677
678 hs-prof-quick:
679         $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
680
681 dist_sbin_SCRIPTS = \
682         tools/ganeti-listrunner
683
684 nodist_sbin_SCRIPTS = \
685         $(PYTHON_BOOTSTRAP_SBIN) \
686         daemons/ganeti-cleaner
687
688 if ENABLE_CONFD
689 htools/ganeti-confd: htools/hconfd
690         cp -f $< $@
691
692 nodist_sbin_SCRIPTS += htools/ganeti-confd
693 endif
694
695 python_scripts = \
696         tools/burnin \
697         tools/cfgshell \
698         tools/cfgupgrade \
699         tools/cfgupgrade12 \
700         tools/cluster-merge \
701         tools/confd-client \
702         tools/fmtjson \
703         tools/lvmstrap \
704         tools/move-instance \
705         tools/ovfconverter \
706         tools/sanitize-config
707
708 dist_tools_SCRIPTS = \
709         $(python_scripts) \
710         tools/kvm-console-wrapper \
711         tools/master-ip-setup \
712         tools/xen-console-wrapper
713
714 nodist_tools_SCRIPTS = \
715         tools/vcluster-setup
716
717 pkglib_python_scripts = \
718         daemons/import-export \
719         tools/check-cert-expired
720
721 nodist_pkglib_python_scripts = \
722         tools/ensure-dirs \
723         tools/prepare-node-join
724
725 myexeclib_SCRIPTS = \
726         daemons/daemon-util \
727         tools/kvm-ifup \
728         $(pkglib_python_scripts)
729
730 nodist_myexeclib_SCRIPTS = \
731         $(nodist_pkglib_python_scripts)
732
733 EXTRA_DIST = \
734         NEWS \
735         UPGRADE \
736         epydoc.conf.in \
737         pylintrc \
738         autotools/build-bash-completion \
739         autotools/build-rpc \
740         autotools/check-header \
741         autotools/check-imports \
742         autotools/check-man-dashes \
743         autotools/check-man-warnings \
744         autotools/check-news \
745         autotools/check-python-code \
746         autotools/check-tar \
747         autotools/check-version \
748         autotools/convert-constants \
749         autotools/docpp \
750         autotools/gen-coverage \
751         autotools/testrunner \
752         autotools/wrong-hardcoded-paths \
753         $(RUN_IN_TEMPDIR) \
754         daemons/daemon-util.in \
755         daemons/ganeti-cleaner.in \
756         $(pkglib_python_scripts) \
757         devel/upload \
758         tools/kvm-ifup.in \
759         tools/vcluster-setup.in \
760         $(docdot) \
761         $(docpng) \
762         $(docrst) \
763         doc/conf.py \
764         doc/html \
765         $(BUILT_EXAMPLES:%=%.in) \
766         doc/examples/ganeti.default \
767         doc/examples/ganeti.default-debug \
768         doc/examples/hooks/ethers \
769         doc/examples/gnt-debug/README \
770         doc/examples/gnt-debug/delay0.json \
771         doc/examples/gnt-debug/delay50.json \
772         test/lockperf.py \
773         test/testutils.py \
774         test/mocks.py \
775         $(dist_TESTS) \
776         $(TEST_FILES) \
777         man/footer.rst \
778         $(manrst) \
779         $(maninput) \
780         qa/qa-sample.json \
781         $(qa_scripts) \
782         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
783         $(HS_PROG_SRCS) \
784         htools/lint-hints.hs \
785         htest/cli-tests-defs.sh \
786         htest/offline-test.sh \
787         .ghci
788
789 man_MANS = \
790         man/ganeti-cleaner.8 \
791         man/ganeti-confd.8 \
792         man/ganeti-listrunner.8 \
793         man/ganeti-masterd.8 \
794         man/ganeti-noded.8 \
795         man/ganeti-os-interface.7 \
796         man/ganeti-rapi.8 \
797         man/ganeti-watcher.8 \
798         man/ganeti.7 \
799         man/gnt-backup.8 \
800         man/gnt-cluster.8 \
801         man/gnt-debug.8 \
802         man/gnt-group.8 \
803         man/gnt-network.8 \
804         man/gnt-instance.8 \
805         man/gnt-job.8 \
806         man/gnt-node.8 \
807         man/gnt-os.8 \
808         man/hail.1 \
809         man/hbal.1 \
810         man/hcheck.1 \
811         man/hinfo.1 \
812         man/hscan.1 \
813         man/hspace.1 \
814         man/htools.1
815
816 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
817 manhtml = $(patsubst %.rst,%.html,$(manrst))
818 mangen = $(patsubst %.rst,%.gen,$(manrst))
819 maninput = \
820         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
821         $(patsubst %.html,%.html.in,$(manhtml)) \
822         man/footer.man man/footer.html $(mangen)
823
824 TEST_FILES = \
825         htest/data/common-suffix.data \
826         htest/data/hail-alloc-drbd.json \
827         htest/data/hail-change-group.json \
828         htest/data/hail-invalid-reloc.json \
829         htest/data/hail-node-evac.json \
830         htest/data/hail-reloc-drbd.json \
831         htest/data/hbal-excl-tags.data \
832         htest/data/hbal-split-insts.data \
833         htest/data/invalid-node.data \
834         htest/data/missing-resources.data \
835         htest/data/rapi/groups.json \
836         htest/data/rapi/info.json \
837         htest/data/rapi/instances.json \
838         htest/data/rapi/nodes.json \
839         htest/shelltests/htools-balancing.test \
840         htest/shelltests/htools-basic.test \
841         htest/shelltests/htools-dynutil.test \
842         htest/shelltests/htools-excl.test \
843         htest/shelltests/htools-hail.test \
844         htest/shelltests/htools-hspace.test \
845         htest/shelltests/htools-invalid.test \
846         htest/shelltests/htools-multi-group.test \
847         htest/shelltests/htools-no-backend.test \
848         htest/shelltests/htools-rapi.test \
849         htest/shelltests/htools-single-group.test \
850         htest/shelltests/htools-text-backend.test \
851         test/data/bdev-drbd-8.0.txt \
852         test/data/bdev-drbd-8.3.txt \
853         test/data/bdev-drbd-disk.txt \
854         test/data/bdev-drbd-net-ip4.txt \
855         test/data/bdev-drbd-net-ip6.txt \
856         test/data/cert1.pem \
857         test/data/cert2.pem \
858         test/data/ip-addr-show-dummy0.txt \
859         test/data/ip-addr-show-lo-ipv4.txt \
860         test/data/ip-addr-show-lo-ipv6.txt \
861         test/data/ip-addr-show-lo-oneline-ipv4.txt \
862         test/data/ip-addr-show-lo-oneline-ipv6.txt \
863         test/data/ip-addr-show-lo-oneline.txt \
864         test/data/ip-addr-show-lo.txt \
865         test/data/kvm_0.12.5_help.txt \
866         test/data/kvm_0.15.90_help.txt \
867         test/data/kvm_0.9.1_help.txt \
868         test/data/kvm_1.0_help.txt \
869         test/data/ovfdata/compr_disk.vmdk.gz \
870         test/data/ovfdata/config.ini \
871         test/data/ovfdata/corrupted_resources.ovf \
872         test/data/ovfdata/empty.ini \
873         test/data/ovfdata/empty.ovf \
874         test/data/ovfdata/ganeti.mf \
875         test/data/ovfdata/ganeti.ovf \
876         test/data/ovfdata/gzip_disk.ovf \
877         test/data/ovfdata/new_disk.vmdk \
878         test/data/ovfdata/no_disk.ini \
879         test/data/ovfdata/no_disk_in_ref.ovf \
880         test/data/ovfdata/no_os.ini \
881         test/data/ovfdata/no_ovf.ova \
882         test/data/ovfdata/other/rawdisk.raw \
883         test/data/ovfdata/ova.ova \
884         test/data/ovfdata/rawdisk.raw \
885         test/data/ovfdata/second_disk.vmdk \
886         test/data/ovfdata/unsafe_path.ini \
887         test/data/ovfdata/virtualbox.ovf \
888         test/data/ovfdata/wrong_config.ini \
889         test/data/ovfdata/wrong_extension.ovd \
890         test/data/ovfdata/wrong_manifest.mf \
891         test/data/ovfdata/wrong_manifest.ovf \
892         test/data/ovfdata/wrong_ova.ova \
893         test/data/ovfdata/wrong_xml.ovf \
894         test/data/proc_drbd8.txt \
895         test/data/proc_drbd80-emptyline.txt \
896         test/data/proc_drbd83.txt \
897         test/data/proc_drbd83_sync.txt \
898         test/data/proc_drbd83_sync_want.txt \
899         test/data/proc_drbd83_sync_krnl2.6.39.txt \
900         test/data/sys_drbd_usermode_helper.txt \
901         test/data/vgreduce-removemissing-2.02.02.txt \
902         test/data/vgreduce-removemissing-2.02.66-fail.txt \
903         test/data/vgreduce-removemissing-2.02.66-ok.txt \
904         test/data/vgs-missing-pvs-2.02.02.txt \
905         test/data/vgs-missing-pvs-2.02.66.txt \
906         test/ganeti-cli.test \
907         test/gnt-cli.test \
908         test/import-export_unittest-helper
909
910 python_tests = \
911         doc/examples/rapi_testutils.py \
912         test/cfgupgrade_unittest.py \
913         test/docs_unittest.py \
914         test/ganeti.asyncnotifier_unittest.py \
915         test/ganeti.backend_unittest-runasroot.py \
916         test/ganeti.backend_unittest.py \
917         test/ganeti.bdev_unittest.py \
918         test/ganeti.cli_unittest.py \
919         test/ganeti.client.gnt_cluster_unittest.py \
920         test/ganeti.client.gnt_instance_unittest.py \
921         test/ganeti.client.gnt_job_unittest.py \
922         test/ganeti.cmdlib_unittest.py \
923         test/ganeti.compat_unittest.py \
924         test/ganeti.confd.client_unittest.py \
925         test/ganeti.config_unittest.py \
926         test/ganeti.constants_unittest.py \
927         test/ganeti.daemon_unittest.py \
928         test/ganeti.errors_unittest.py \
929         test/ganeti.hooks_unittest.py \
930         test/ganeti.ht_unittest.py \
931         test/ganeti.http_unittest.py \
932         test/ganeti.hypervisor.hv_chroot_unittest.py \
933         test/ganeti.hypervisor.hv_fake_unittest.py \
934         test/ganeti.hypervisor.hv_kvm_unittest.py \
935         test/ganeti.hypervisor.hv_lxc_unittest.py \
936         test/ganeti.hypervisor.hv_xen_unittest.py \
937         test/ganeti.hypervisor_unittest.py \
938         test/ganeti.impexpd_unittest.py \
939         test/ganeti.jqueue_unittest.py \
940         test/ganeti.jstore_unittest.py \
941         test/ganeti.locking_unittest.py \
942         test/ganeti.luxi_unittest.py \
943         test/ganeti.masterd.iallocator_unittest.py \
944         test/ganeti.masterd.instance_unittest.py \
945         test/ganeti.mcpu_unittest.py \
946         test/ganeti.netutils_unittest.py \
947         test/ganeti.objects_unittest.py \
948         test/ganeti.objectutils_unittest.py \
949         test/ganeti.opcodes_unittest.py \
950         test/ganeti.ovf_unittest.py \
951         test/ganeti.qlang_unittest.py \
952         test/ganeti.query_unittest.py \
953         test/ganeti.rapi.baserlib_unittest.py \
954         test/ganeti.rapi.client_unittest.py \
955         test/ganeti.rapi.resources_unittest.py \
956         test/ganeti.rapi.rlib2_unittest.py \
957         test/ganeti.rapi.testutils_unittest.py \
958         test/ganeti.rpc_unittest.py \
959         test/ganeti.runtime_unittest.py \
960         test/ganeti.serializer_unittest.py \
961         test/ganeti.server.rapi_unittest.py \
962         test/ganeti.ssconf_unittest.py \
963         test/ganeti.ssh_unittest.py \
964         test/ganeti.storage_unittest.py \
965         test/ganeti.tools.ensure_dirs_unittest.py \
966         test/ganeti.tools.prepare_node_join_unittest.py \
967         test/ganeti.uidpool_unittest.py \
968         test/ganeti.utils.algo_unittest.py \
969         test/ganeti.utils.filelock_unittest.py \
970         test/ganeti.utils.hash_unittest.py \
971         test/ganeti.utils.io_unittest-runasroot.py \
972         test/ganeti.utils.io_unittest.py \
973         test/ganeti.utils.log_unittest.py \
974         test/ganeti.utils.mlock_unittest.py \
975         test/ganeti.utils.nodesetup_unittest.py \
976         test/ganeti.utils.process_unittest.py \
977         test/ganeti.utils.retry_unittest.py \
978         test/ganeti.utils.text_unittest.py \
979         test/ganeti.utils.wrapper_unittest.py \
980         test/ganeti.utils.x509_unittest.py \
981         test/ganeti.utils_unittest.py \
982         test/ganeti.vcluster_unittest.py \
983         test/ganeti.workerpool_unittest.py \
984         test/pycurl_reset_unittest.py \
985         test/qa.qa_config_unittest.py \
986         test/tempfile_fork_unittest.py
987
988 haskell_tests = htest/test
989
990 dist_TESTS = \
991         test/check-cert-expired_unittest.bash \
992         test/daemon-util_unittest.bash \
993         test/ganeti-cleaner_unittest.bash \
994         test/import-export_unittest.bash \
995         test/cli-test.bash \
996         test/bash_completion.bash \
997         $(python_tests)
998
999 nodist_TESTS =
1000 check_SCRIPTS =
1001
1002 if WANT_HTOOLSTESTS
1003 nodist_TESTS += $(haskell_tests)
1004 dist_TESTS += htest/offline-test.sh
1005 check_SCRIPTS += htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
1006 endif
1007
1008 TESTS = $(dist_TESTS) $(nodist_TESTS)
1009
1010 # Environment for all tests
1011 PLAIN_TESTS_ENVIRONMENT = \
1012         PYTHONPATH=. \
1013         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1014         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1015         $(RUN_IN_TEMPDIR)
1016
1017 # Environment for tests run by automake
1018 TESTS_ENVIRONMENT = \
1019         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1020
1021 all_python_code = \
1022         $(dist_sbin_SCRIPTS) \
1023         $(python_scripts) \
1024         $(pkglib_python_scripts) \
1025         $(nodist_pkglib_python_scripts) \
1026         $(python_tests) \
1027         $(pkgpython_PYTHON) \
1028         $(client_PYTHON) \
1029         $(hypervisor_PYTHON) \
1030         $(rapi_PYTHON) \
1031         $(server_PYTHON) \
1032         $(pytools_PYTHON) \
1033         $(http_PYTHON) \
1034         $(confd_PYTHON) \
1035         $(masterd_PYTHON) \
1036         $(impexpd_PYTHON) \
1037         $(utils_PYTHON) \
1038         $(watcher_PYTHON) \
1039         $(noinst_PYTHON) \
1040         $(qa_scripts)
1041
1042 srclink_files = \
1043         man/footer.rst \
1044         test/check-cert-expired_unittest.bash \
1045         test/daemon-util_unittest.bash \
1046         test/ganeti-cleaner_unittest.bash \
1047         test/import-export_unittest.bash \
1048         test/cli-test.bash \
1049         test/bash_completion.bash \
1050         htest/offline-test.sh \
1051         htest/cli-tests-defs.sh \
1052         $(all_python_code) \
1053         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1054
1055 check_python_code = \
1056         $(BUILD_BASH_COMPLETION) \
1057         $(CHECK_IMPORTS) \
1058         $(CHECK_HEADER) \
1059         $(DOCPP) \
1060         $(all_python_code)
1061
1062 lint_python_code = \
1063         ganeti \
1064         ganeti/http/server.py \
1065         $(dist_sbin_SCRIPTS) \
1066         $(python_scripts) \
1067         $(pkglib_python_scripts) \
1068         $(BUILD_BASH_COMPLETION) \
1069         $(CHECK_IMPORTS) \
1070         $(CHECK_HEADER) \
1071         $(DOCPP) \
1072         $(PYTHON_BOOTSTRAP)
1073
1074 standalone_python_modules = \
1075         lib/rapi/client.py \
1076         tools/ganeti-listrunner
1077
1078 pep8_python_code = \
1079         ganeti \
1080         ganeti/http/server.py \
1081         $(dist_sbin_SCRIPTS) \
1082         $(python_scripts) \
1083         $(pkglib_python_scripts) \
1084         $(BUILD_BASH_COMPLETION) \
1085         $(CHECK_HEADER) \
1086         $(DOCPP) \
1087         $(PYTHON_BOOTSTRAP) \
1088         qa
1089
1090 test/daemon-util_unittest.bash: daemons/daemon-util
1091
1092 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1093
1094 test/bash_completion.bash: doc/examples/bash_completion-debug
1095
1096 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1097         sed -f $(REPLACE_VARS_SED) < $< > $@
1098         chmod +x $@
1099
1100 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1101         sed -f $(REPLACE_VARS_SED) < $< > $@
1102         chmod +x $@
1103
1104 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1105         sed -f $(REPLACE_VARS_SED) < $< > $@
1106         chmod +x $@
1107
1108 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1109         sed -f $(REPLACE_VARS_SED) < $< > $@
1110
1111 doc/examples/bash_completion: BC_ARGS = --compact
1112 doc/examples/bash_completion-debug: BC_ARGS =
1113
1114 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1115         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1116         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1117         daemons/ganeti-cleaner \
1118         $(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1119         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1120           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1121
1122 doc/%.png: doc/%.dot
1123         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1124         $(DOT) -Tpng -o $@ $<
1125
1126 man/footer.man: man/footer.rst
1127         @test -n "$(PANDOC)" || \
1128           { echo 'pandoc' not found during configure; exit 1; }
1129         $(PANDOC) -f rst -t man -o $@ $<
1130
1131 man/footer.html: man/footer.rst
1132         @test -n "$(PANDOC)" || \
1133           { echo 'pandoc' not found during configure; exit 1; }
1134         $(PANDOC) -f rst -t html -o $@ $<
1135
1136 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1137         lib/build/shell_example_lexer.py \
1138         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1139         @echo "Checking $< for hardcoded paths..."
1140         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1141           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1142           exit 1; \
1143         fi
1144         set -e ; \
1145         trap 'echo auto-removing $@; rm $@' EXIT; \
1146         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1147         trap - EXIT
1148
1149 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1150         @test -n "$(PANDOC)" || \
1151           { echo 'pandoc' not found during configure; exit 1; }
1152         set -o pipefail ; \
1153         trap 'echo auto-removing $@; rm $@' EXIT; \
1154         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1155           sed -e 's/\\@/@/g' > $@; \
1156         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1157         $(CHECK_MAN_DASHES) $@; \
1158         trap - EXIT
1159
1160
1161 man/%.html.in: man/%.gen man/footer.html
1162         @test -n "$(PANDOC)" || \
1163           { echo 'pandoc' not found during configure; exit 1; }
1164         set -o pipefail ; \
1165         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1166           sed -e 's/\\@/@/g' > $@
1167
1168 man/%: man/%.in  $(REPLACE_VARS_SED)
1169         sed -f $(REPLACE_VARS_SED) < $< > $@
1170
1171 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1172         sed -f $(REPLACE_VARS_SED) < $< > $@
1173
1174 vcs-version:
1175         if test -d .git; then \
1176           git describe > $@; \
1177         elif test ! -f $@ ; then \
1178           echo "Cannot auto-generate $@ file"; exit 1; \
1179         fi
1180
1181 .PHONY: clean-vcs-version
1182 clean-vcs-version:
1183         rm -f vcs-version
1184
1185 .PHONY: regen-vcs-version
1186 regen-vcs-version:
1187         @set -e; \
1188         cd $(srcdir); \
1189         if test -d .git; then \
1190           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1191           git describe > $$T; \
1192           if ! cmp --quiet $$T vcs-version; then \
1193             mv $$T vcs-version; \
1194           fi; \
1195         fi
1196
1197 htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1198         vcs-version $(built_base_sources)
1199         set -e; \
1200         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1201         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1202
1203 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1204         lib/constants.py lib/_autoconf.py lib/luxi.py \
1205         $(CONVERT_CONSTANTS) $(built_base_sources) \
1206         | lib/_vcsversion.py
1207         set -e; \
1208         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1209
1210 htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1211         $(built_base_sources)
1212         set -e; \
1213         { cat $< ; \
1214           echo ; \
1215           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1216             echo "import $$name ()" ; \
1217           done ; \
1218         } > $@
1219
1220 lib/_autoconf.py: Makefile | stamp-directories
1221         set -e; \
1222         { echo '# This file is automatically generated, do not edit!'; \
1223           echo '#'; \
1224           echo ''; \
1225           echo '"""Build-time configuration for Ganeti.'; \
1226           echo '';\
1227           echo 'This file is autogenerated by the build process.'; \
1228           echo 'For any changes you need to re-run ./configure (and'; \
1229           echo 'not edit by hand).'; \
1230           echo ''; \
1231           echo '"""'; \
1232           echo ''; \
1233           echo '# pylint: disable=C0301,C0324'; \
1234           echo '# because this is autogenerated, we do not want'; \
1235           echo '# style warnings' ; \
1236           echo ''; \
1237           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1238           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1239           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1240           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1241           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1242           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1243           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1244           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1245           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1246           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1247           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1248           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1249           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1250           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1251           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1252           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1253           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1254           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1255           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1256           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1257           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1258           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1259           echo "KVM_PATH = '$(KVM_PATH)'"; \
1260           echo "IP_PATH = '$(IP_PATH)'"; \
1261           echo "SOCAT_PATH = '$(SOCAT)'"; \
1262           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1263           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1264           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1265           echo "TOOLSDIR = '$(toolsdir)'"; \
1266           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1267           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1268           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1269           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1270           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1271           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1272           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1273           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1274           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1275           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1276           echo "RAPI_USER = '$(RAPI_USER)'"; \
1277           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1278           echo "CONFD_USER = '$(CONFD_USER)'"; \
1279           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1280           echo "NODED_USER = '$(NODED_USER)'"; \
1281           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1282           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1283           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1284           echo "HTOOLS = True"; \
1285           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1286           echo "XEN_CMD = '$(XEN_CMD)'"; \
1287           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1288           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1289         } > $@
1290
1291 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1292         set -e; \
1293         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1294         { echo '# This file is automatically generated, do not edit!'; \
1295           echo '#'; \
1296           echo ''; \
1297           echo '"""Build-time VCS version number for Ganeti.'; \
1298           echo '';\
1299           echo 'This file is autogenerated by the build process.'; \
1300           echo 'For any changes you need to re-run ./configure (and'; \
1301           echo 'not edit by hand).'; \
1302           echo ''; \
1303           echo '"""'; \
1304           echo ''; \
1305           echo '# pylint: disable=C0301,C0324'; \
1306           echo '# because this is autogenerated, we do not want'; \
1307           echo '# style warnings' ; \
1308           echo ''; \
1309           echo "VCS_VERSION = '$$VCSVER'"; \
1310         } > $@
1311
1312 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1313         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1314
1315 $(SHELL_ENV_INIT): Makefile stamp-directories
1316         set -e; \
1317         { echo '# Allow overriding for tests'; \
1318           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1319           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1320           echo; \
1321           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1322           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1323           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1324           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1325           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1326         } > $@
1327
1328 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1329         set -e; \
1330         { echo 's#@PREFIX@#$(prefix)#g'; \
1331           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1332           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1333           echo 's#@BINDIR@#$(bindir)#g'; \
1334           echo 's#@SBINDIR@#$(sbindir)#g'; \
1335           echo 's#@LIBDIR@#$(libdir)#g'; \
1336           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1337           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1338           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1339           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1340           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1341           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1342           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1343           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1344           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1345           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1346           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1347           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1348           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1349           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1350           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1351           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1352           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1353           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1354           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1355           echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1356           echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1357           echo; \
1358           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1359           echo '  r $(SHELL_ENV_INIT)'; \
1360           echo '  d'; \
1361           echo '}'; \
1362         } > $@
1363
1364 # Using deferred evaluation
1365 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1366 daemons/ganeti-watcher: MODULE = ganeti.watcher
1367 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1368 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1369 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1370 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1371
1372 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1373         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1374         set -e; \
1375         { echo '#!/usr/bin/python'; \
1376           echo '# This file is automatically generated, do not edit!'; \
1377           echo "# Edit $(MODULE) instead."; \
1378           echo; \
1379           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1380           echo; \
1381           echo '# pylint: disable=C0103'; \
1382           echo '# C0103: Invalid name'; \
1383           echo; \
1384           echo 'import sys'; \
1385           echo 'import $(MODULE) as main'; \
1386           echo; \
1387           echo '# Temporarily alias commands until bash completion'; \
1388           echo '# generator is changed'; \
1389           echo 'if hasattr(main, "commands"):'; \
1390           echo '  commands = main.commands # pylint: disable=E1101'; \
1391           echo 'if hasattr(main, "aliases"):'; \
1392           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1393           echo; \
1394           echo 'if __name__ == "__main__":'; \
1395           echo '  sys.exit(main.Main())'; \
1396         } > $@
1397         chmod u+x $@
1398
1399 $(HS_BUILT_TEST_HELPERS): Makefile
1400         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1401         set -e; \
1402         { echo '#!/bin/sh'; \
1403           echo '# This file is automatically generated, do not edit!'; \
1404           echo "# Edit Makefile.am instead."; \
1405           echo; \
1406           echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1407         } > $@
1408         chmod u+x $@
1409
1410 stamp-directories: Makefile
1411         $(MAKE) $(AM_MAKEFLAGS) ganeti
1412         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1413         touch $@
1414
1415 # We need to create symlinks because "make distcheck" will not install Python
1416 # files when building.
1417 stamp-srclinks: Makefile | stamp-directories
1418         set -e; \
1419         for i in $(srclink_files); do \
1420                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1421                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1422                 fi; \
1423         done
1424         touch $@
1425
1426 .PHONY: ganeti
1427 ganeti:
1428         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1429
1430 .PHONY: check-dirs
1431 check-dirs: $(GENERATED_FILES)
1432         @set -e; \
1433         find . -type d \( \( -name . \) -o \( \
1434                 -name .git -o \
1435                 -name autom4te.cache \
1436                 \) -prune -o -print \) | { \
1437                 error=; \
1438                 while read dir; do \
1439                         case "$$dir" in \
1440                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1441                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1442                         esac; \
1443                 done; \
1444                 for dir in $(DIRS); do \
1445                         if ! test -d "$$dir"; then \
1446                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1447                                 error=1; \
1448                         fi \
1449                 done; \
1450                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1451         }
1452
1453 .PHONY: check-local
1454 check-local: check-dirs $(GENERATED_FILES)
1455         $(CHECK_PYTHON_CODE) $(check_python_code)
1456         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1457         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1458         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1459         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1460         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1461         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1462                 echo "Incorrect version in README, expected $$expver"; \
1463                 exit 1; \
1464         fi; \
1465         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1466                         doc/security.rst; do \
1467                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1468                         "Documents Ganeti version $$expver"; then \
1469                         echo "Incorrect version in $$file, expected $$expver"; \
1470                         exit 1; \
1471                 fi; \
1472         done; \
1473         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1474                 echo "File $(top_srcdir)/doc/design-$$expver.rst not found"; \
1475                 exit 1; \
1476         fi; \
1477         if test $$(wc --max-line-length < $(top_srcdir)/configure.ac) -gt 80; then \
1478                 echo 'Longest line in configure.ac is longer than 80 characters' >&2; \
1479         fi
1480
1481 .PHONY: hs-check
1482 hs-check: htest/test htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
1483         @rm -f test.tix
1484         ./htest/test
1485         HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1486
1487 # E111: indentation is not a multiple of four
1488 # E121: continuation line indentation is not a multiple of four
1489 #       (since our indent level is not 4)
1490 # E125: continuation line does not distinguish itself from next logical line
1491 #       (since our indent level is not 4)
1492 # E127: continuation line over-indented for visual indent
1493 #       (since our indent level is not 4)
1494 # note: do NOT add E128 here; it's a valid style error in most cases!
1495 # I've seen real errors, but also some cases were we indent wrongly
1496 # due to line length; try to rework the cases where it is triggered,
1497 # instead of silencing it
1498 # E261: at least two spaces before inline comment
1499 # E501: line too long (80 characters)
1500 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1501
1502 # For excluding pep8 expects filenames only, not whole paths
1503 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1504
1505 LINT_TARGETS = pylint pylint-qa
1506 if HAS_PEP8
1507 LINT_TARGETS += pep8
1508 endif
1509 if HAS_HLINT
1510 LINT_TARGETS += hlint
1511 endif
1512
1513 .PHONY: lint
1514 lint: $(LINT_TARGETS)
1515
1516 .PHONY: pylint
1517 pylint: $(GENERATED_FILES)
1518         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1519         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1520
1521 .PHONY: pylint-qa
1522 pylint-qa: $(GENERATED_FILES)
1523         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1524         cd $(top_srcdir)/qa && \
1525           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1526           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1527
1528 .PHONY: pep8
1529 pep8: $(GENERATED_FILES)
1530         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1531         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1532                 --repeat $(pep8_python_code)
1533
1534 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1535 .PHONY: hlint
1536 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1537         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1538         if tty -s; then C="-c"; else C=""; fi; \
1539         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1540           --ignore "Use first" \
1541           --ignore "Use comparing" \
1542           --ignore "Use on" \
1543           --ignore "Reduce duplication" \
1544           --ignore "Use &&&" \
1545           --ignore "Use void" \
1546           --hint htools/lint-hints \
1547           $(filter-out htools/Ganeti/THH.hs,$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1548
1549 # a dist hook rule for updating the vcs-version file; this is
1550 # hardcoded due to where it needs to build the file...
1551 dist-hook:
1552         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1553         rm -f $(top_distdir)/vcs-version
1554         cp -p $(srcdir)/vcs-version $(top_distdir)
1555
1556 # a distcheck hook rule for catching revision control directories
1557 distcheck-hook:
1558         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1559                 echo "Found revision control files in final archive." 1>&2; \
1560                 exit 1; \
1561         fi
1562         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1563                 echo "Found Python byte code in final archive." 1>&2; \
1564                 exit 1; \
1565         fi
1566         if find $(top_distdir) -name '*~' | grep .; then \
1567                 echo "Found backup files in final archive." 1>&2; \
1568                 exit 1; \
1569         fi
1570 # Empty files or directories should not be distributed. They can cause
1571 # unnecessary warnings for packagers. Directories used by automake during
1572 # distcheck must be excluded.
1573         if find $(top_distdir) -empty -and -not \( \
1574                         -path $(top_distdir)/_build -or \
1575                         -path $(top_distdir)/_inst \) | grep .; then \
1576                 echo "Found empty files or directories in final archive." 1>&2; \
1577                 exit 1; \
1578         fi
1579         if test -n "$(BUILD_RELEASE)" && \
1580            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1581                 echo "Found unreleased version in NEWS." >&2; \
1582                 exit 1; \
1583         fi
1584
1585 # When building a release, stricter checks should be used
1586 distcheck-release dist-release: export BUILD_RELEASE = 1
1587 distcheck-release: distcheck
1588
1589 distrebuildcheck: dist
1590         set -e; \
1591         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1592         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1593         cd $$builddir; \
1594         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1595         cd $(distdir); \
1596         ./configure; \
1597         $(MAKE) maintainer-clean; \
1598         cp $(abs_srcdir)/vcs-version .; \
1599         ./configure; \
1600         $(MAKE) $(AM_MAKEFLAGS)
1601
1602 dist-release: dist
1603         set -e; \
1604         for i in $(DIST_ARCHIVES); do \
1605                 echo -n "Checking $$i ... "; \
1606                 autotools/check-tar < $$i; \
1607                 echo OK; \
1608         done
1609
1610 install-exec-local:
1611         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1612           "$(DESTDIR)${localstatedir}/log/ganeti" \
1613           "$(DESTDIR)${localstatedir}/run/ganeti"
1614
1615 .PHONY: apidoc
1616 if WANT_HTOOLSAPIDOC
1617 apidoc: py-apidoc hs-apidoc
1618 else
1619 apidoc: py-apidoc
1620 endif
1621
1622 .PHONY: py-apidoc
1623 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1624         $(RUN_IN_TEMPDIR) epydoc -v \
1625                 --conf $(CURDIR)/epydoc.conf \
1626                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1627
1628 .PHONY: hs-apidoc
1629 hs-apidoc: $(HS_BUILT_SRCS)
1630         @test -n "$(HSCOLOUR)" || \
1631             { echo 'HsColour' not found during configure; exit 1; }
1632         @test -n "$(HADDOCK)" || \
1633             { echo 'haddock' not found during configure; exit 1; }
1634         rm -rf $(APIDOC_HS_DIR)/*
1635         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Backend
1636         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1637         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Block
1638         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Block/Drbd
1639         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1640         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Query
1641         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1642         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1643         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1644         set -e ; \
1645         cd htools; \
1646         if [ "$(HTOOLS_NOCURL)" ]; \
1647         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1648         else OPTGHC=""; \
1649         fi; \
1650         if [ "$(HTOOLS_PARALLEL3)" ]; \
1651         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1652         fi; \
1653         if [ "$(HTOOLS_REGEX_PCRE)" ]; \
1654         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_REGEX_PCRE)"; \
1655         fi; \
1656         RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1657         for file in $$RELSRCS; do \
1658                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1659                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1660         done ; \
1661         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1662                 -t ganeti -p haddock-prologue \
1663                 --source-module="%{MODULE/.//}.html" \
1664                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1665                 $$OPTGHC \
1666                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1667
1668 .PHONY: TAGS
1669 TAGS: $(GENERATED_FILES)
1670         rm -f TAGS
1671         $(GHC) -e ":etags" -v0 \
1672           $(filter-out -O -Werror,$(HFLAGS)) \
1673           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
1674           $(HS_LIBTEST_SRCS)
1675         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1676           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1677           -path './qa/*.py' | \
1678           etags -l python -a -
1679
1680 .PHONY: coverage
1681 if WANT_HTOOLS
1682 coverage: py-coverage hs-coverage
1683 else
1684 coverage: py-coverage
1685 endif
1686
1687 .PHONY: py-coverage
1688 py-coverage: $(GENERATED_FILES) $(python_tests)
1689         @test -n "$(PYCOVERAGE)" || \
1690             { echo 'python-coverage' not found during configure; exit 1; }
1691         set -e; \
1692         COVERAGE=$(PYCOVERAGE) \
1693         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1694         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1695         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1696         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1697         $(python_tests)
1698
1699 .PHONY: hs-coverage
1700 hs-coverage: $(haskell_tests) htest/hpc-htools
1701         rm -f *.tix
1702         $(MAKE) $(AM_MAKEFLAGS) hs-check
1703         @mkdir_p@ $(COVERAGE_HS_DIR)
1704         hpc combine --union $(HPCEXCL) \
1705           test.tix hpc-htools.tix > coverage-htools.tix
1706         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1707         hpc report coverage-htools.tix
1708         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1709
1710 # Special "kind-of-QA" target for htools, needs special setup (all
1711 # tools compiled with -fhpc)
1712 .PHONY: live-test
1713 live-test: all
1714         set -e ; \
1715         cd htools; \
1716         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1717         rm -f *.tix *.mix; \
1718         ./live-test.sh; \
1719         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1720           --output=live-test.tix ; \
1721         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1722         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1723                 --srcdir=.. $(HPCEXCL) ; \
1724         hpc report --srcdir=.. live-test $(HPCEXCL)
1725
1726 commit-check: distcheck lint apidoc
1727
1728 .PHONY: gitignore-check
1729 gitignore-check:
1730         @if [ -n "`git status --short`" ]; then \
1731           echo "Git status is not clean!" 1>&2 ; \
1732           git status --short; \
1733           exit 1; \
1734         fi
1735
1736 # Target that builds all binaries (including those that are not
1737 # rebuilt except when running the tests)
1738 .PHONY: really-all
1739 really-all: all $(check_SCRIPTS) $(haskell_tests)
1740
1741 # we don't need the ancient implicit rules:
1742 %: %,v
1743 %: RCS/%,v
1744 %: RCS/%
1745 %: s.%
1746 %: SCCS/s.%
1747
1748 -include ./Makefile.local
1749
1750 # vim: set noet :